private static const ACTIVATION_SHOW:int = 1;
private static const ACTIVATION_WAIT:int = 2;
private static const ACTIVATION_HIDE:int = 3;

private var activationState:int = ACTIVATION_SHOW;
private var activationTime:Number = 0;
private var lastOpacity:Number = 0;

private function Draw_Activation(ellapsedTime:Number):void
{   
  activationTime += ellapsedTime;
  
  Draw_TitleScreen();
 
  switch (activationState)
  {
  case ACTIVATION_SHOW:    
    //Apply_FadeEffect(1 - activationTime);     
    
    //if (activationTime >= 1)
    ChangeState_Activation(ACTIVATION_WAIT);
    break;
  case ACTIVATION_WAIT:
    /*var fracTime:Number = activationTime - int(activationTime);
     
    switch (int(activationTime) % 4)
    {
    case 0: 
      lastOpacity = fracTime;
      Draw_ActivationBanner(lastOpacity); 
      break;
    case 1:
      lastOpacity = 1;
      Draw_ActivationBanner(lastOpacity);     
      break;
    case 2:
      lastOpacity = 1 - fracTime;
      Draw_ActivationBanner(lastOpacity);     
      break;
    case 3:
      activationTime += ellapsedTime;    
      lastOpacity = 0;
      Draw_ActivationBanner(lastOpacity);     
      break;      
    }*/
    Draw_ActivationBanner(1);     
    break;    
  case ACTIVATION_HIDE:    
    Draw_ActivationBanner(1 - activationTime * 2);  
  
    if (activationTime >= 0.5)
    {
      state = GAME_MENU;
      ChangeState_GameMenu(GAMEOPTIONS_IN);
    } 
    break;  
  }    
}

private function ChangeState_Activation(newState:int):void
{  
  activationState = newState;
  activationTime = 0;
}

[Embed(source="Images/ActivationBanner.png")] private var activationBannerImg:Class;

private var activationBannerBitmap:BitmapData = null;

private function Draw_ActivationBanner(opacity:Number):void
{
  if (activationBannerBitmap == null)
  {
    activationBannerBitmap = new BitmapData(330,330,true,0x00000000);
    activationBannerBitmap.draw(new activationBannerImg());
  }
  
  if (opacity > 0.5)  
    screenBuffer.copyPixels(activationBannerBitmap,
                            new Rectangle(21, 8, 286, 36),
                            new Point(96,305));   
  
  if (opacity > 0.9)
    screenBuffer.copyPixels(activationBannerBitmap,
                            new Rectangle(0, 50, 330, 70),
                            new Point(75,290)); 
  else
  if (opacity > 0.65)
    screenBuffer.copyPixels(activationBannerBitmap,
                            new Rectangle(0, 120, 330, 70),
                            new Point(75,290));
  else
  if (opacity > 0.40)
    screenBuffer.copyPixels(activationBannerBitmap,
                            new Rectangle(0, 190, 330, 70),
                            new Point(75,290));
  else
  if (opacity > 0.15)
    screenBuffer.copyPixels(activationBannerBitmap,
                            new Rectangle(0, 260, 330, 70),
                            new Point(75,290));
}

private function MouseDown_Activation(event:MouseEvent):void 	
{	
  if (activationState == ACTIVATION_WAIT)
    PlaySound(ACTIVATED_SOUND);  
}
	
private function MouseUp_Activation(event:MouseEvent):void 	
{	
  if (activationState == ACTIVATION_WAIT)
    ChangeState_Activation(ACTIVATION_HIDE);
}
