package Classes 
{
  import flash.geom.*; 
  import flash.display.*;
  
  public class Background
  {     
    private static const SCREEN_WIDTH:int     = 480;
    private static const SCREEN_HEIGHT:int    = 480; 
  
    [Embed(source="../Images/LevelBackground_1.jpg")] private var levelBackground_1Img:Class;
    [Embed(source="../Images/LevelCollision_1.jpg")] private var levelColission_1Img:Class; 
    [Embed(source="../Images/LevelBackground_2.jpg")] private var levelBackground_2Img:Class;
    [Embed(source="../Images/LevelCollision_2.jpg")] private var levelColission_2Img:Class; 
    [Embed(source="../Images/LevelBackground_3.jpg")] private var levelBackground_3Img:Class;
    [Embed(source="../Images/LevelCollision_3.jpg")] private var levelColission_3Img:Class;  
    [Embed(source="../Images/LevelBackground_4.jpg")] private var levelBackground_4Img:Class;
    [Embed(source="../Images/LevelCollision_4.jpg")] private var levelColission_4Img:Class;   
    [Embed(source="../Images/LevelBackground_5.jpg")] private var levelBackground_5Img:Class;
    [Embed(source="../Images/LevelCollision_5.jpg")] private var levelColission_5Img:Class; 

    private var bitmap:BitmapData = null;
    private var bitmapCollision:BitmapData = null;    
    private var height:int = 0;
    
    public function Background(level:int) 
    {      
      switch (level)
      {
      case 1:
        height = 2000;
      
        if (bitmap == null)
        {
          bitmap = new BitmapData(480,height,true,0x00000000);
          bitmap.draw(new levelBackground_1Img());
        }
              
        if (bitmapCollision == null)
        {
          bitmapCollision = new BitmapData(480,height,true,0x00000000);
          bitmapCollision.draw(new levelColission_1Img());
        }   
        break;
      case 2:
        height = 2400;
      
        if (bitmap == null)
        {
          bitmap = new BitmapData(480,height,true,0x00000000);
          bitmap.draw(new levelBackground_2Img());
        }
              
        if (bitmapCollision == null)
        {
          bitmapCollision = new BitmapData(480,height,true,0x00000000);
          bitmapCollision.draw(new levelColission_2Img());
        }   
        break; 
      case 3:
        height = 2500;
      
        if (bitmap == null)
        {
          bitmap = new BitmapData(480,height,true,0x00000000);
          bitmap.draw(new levelBackground_3Img());
        }
              
        if (bitmapCollision == null)
        {
          bitmapCollision = new BitmapData(480,height,true,0x00000000);
          bitmapCollision.draw(new levelColission_3Img());
        }   
        break; 
      case 4:
        height = 2600;
      
        if (bitmap == null)
        {
          bitmap = new BitmapData(480,height,true,0x00000000);
          bitmap.draw(new levelBackground_4Img());
        }
              
        if (bitmapCollision == null)
        {
          bitmapCollision = new BitmapData(480,height,true,0x00000000);
          bitmapCollision.draw(new levelColission_4Img());
        }   
        break; 
      case 5:
        height = 2300;
      
        if (bitmap == null)
        {
          bitmap = new BitmapData(480,height,true,0x00000000);
          bitmap.draw(new levelBackground_5Img());
        }
              
        if (bitmapCollision == null)
        {
          bitmapCollision = new BitmapData(480,height,true,0x00000000);
          bitmapCollision.draw(new levelColission_5Img());
        }   
        break; 
      }
    }
    
    public function getHeight():int
    {
      return height;
    }
    
    public function checkCollision(bounds:Rectangle):Boolean
    {
      for (var y:int = bounds.y; y > bounds.y - bounds.height; y--)
        for (var x:int = bounds.x; x < bounds.x + bounds.width; x++)      
          if (bitmapCollision.getPixel32(x, (bitmap.height - y) % bitmap.height) < 0xFFF00000)
            return true;
        
      return false;
    }    
        
    public function draw(screenBuffer:BitmapData,visible:Rectangle):void
    {
      /*var start:int = bitmap.height - visible.y % bitmap.height;
      var end:int = start + SCREEN_HEIGHT > bitmap.height ? bitmap.height - start : SCREEN_HEIGHT;
    
      screenBuffer.copyPixels(bitmap,
                              new Rectangle(0,start,SCREEN_WIDTH,end),
                              new Point(0,0));
                
      if (end < SCREEN_HEIGHT)           
        screenBuffer.copyPixels(bitmap,
                                new Rectangle(0,0,SCREEN_WIDTH,SCREEN_WIDTH - end),
                                new Point(0,end));*/
                                
      var start:int = bitmap.height - visible.y;
      
      if (start > 0)
        screenBuffer.copyPixels(bitmap,
                                new Rectangle(0,start,SCREEN_WIDTH,SCREEN_HEIGHT),
                                new Point(0,0));         
      else
      {
        if (start > -SCREEN_HEIGHT)
          screenBuffer.copyPixels(bitmap,
                                  new Rectangle(0,0,SCREEN_WIDTH,SCREEN_HEIGHT),
                                  new Point(0,-start)); 
                                  
        while (start < 98)
        {
          screenBuffer.copyPixels(bitmap,
                                  new Rectangle(0,0,SCREEN_WIDTH,98),
                                  new Point(0,-start));
                                  
          start += 98;
        }                                
      }                            
    }
  } 
}
