package Classes 
{
  import flash.geom.*; 
  import flash.display.*; 

  public class ButterFly
  {
    private var x:Number = 0;
    private var y:Number = 0;    
    private var angle:int = 0;
    private var color:int = 0;
    private var flip:int = 0;
      
    public function ButterFly(x:int,y:int) 
    {         
      this.x = x; 
      this.y = y;  
      angle = int(Math.random() * 8.5 + 2) * 30;
      color = int(Math.random() * 6.5);
    }
    
    public function getPosition():Point
    {
      return new Point(int(x),int(y));
    }
        
    public function update():Boolean
    {
      var rnd:int = (int)(Math.random() * 50);
    
      if (rnd == 25)
      {
        angle += 30;
      
        if (angle == 360)
          angle = 0;
      }
      else
        if (rnd == 35)      
        {
          angle -= 30;
      
          if (angle == -30)
            angle = 330;
        } 
        
      var kx:int = 0;
      var ky:int = 0;      
        
      switch (angle)
      {
      case 0:
        ky = 3;
        break;
      case 30:
        ky = 2;
        kx = 1;        
        break;  
      case 60:
        ky = 1;
        kx = 2;        
        break; 
      case 90:
        kx = 3;
        break;
      case 120:
        ky = -1;
        kx = 2;        
        break; 
      case 150:
        ky = -2;
        kx = 1;        
        break; 
      case 180:
        ky = -3;
        break; 
      case 210:
        ky = -2;
        kx = -1;        
        break; 
      case 240:
        ky = -1;
        kx = -2;        
        break; 
      case 270:
        kx = -3;
        break; 
      case 300:
        ky = 1;
        kx = -2;        
        break; 
      case 330:
        ky = 2;
        kx = -1;        
        break;
      }   
      
      x += kx / 2;
      y += ky / 2;     
      
      flip++;
      
      if (flip == 6)
        flip = 0;
      
      return true;
    }
    
    [Embed(source="../Images/ButterFly.png")] private var butterFlyImg:Class;

    private var bitmap:BitmapData = null;
        
    public function draw(screenBuffer:BitmapData,visible:Rectangle):void
    {
      if (bitmap == null)
      {
        bitmap = new BitmapData(480,120,true,0x00000000);
        bitmap.draw(new butterFlyImg());
      }    
    
      screenBuffer.copyPixels(bitmap,
                              new Rectangle(angle / 30 * 20 + (flip >= 3 ? 240 : 0),color * 20,20,20),
                              new Point(int(x) - 10,visible.y - int(y) - 10)); 
    }
  } 
}
