package Classes 
{
  import flash.geom.*; 
  import flash.display.*; 

  public class Egg
  {
    private var position:Point = null;
    private var eaten:Boolean = false;
    private var blinking:int = 0;
    private var phase:int = 0;
      
    public function Egg(x:int,y:int) 
    {      
      phase = 10;   
    
      position = new Point(x,y);     
    }
    
    public function getPosition():Point
    {
      return position;
    }
    
    public function getBounds():Rectangle    
    { 
      return new Rectangle(position.x - 6, position.y + 8, 13, 19);
    }
    
    public function getBounds2(margin:int):Rectangle    
    { 
      return new Rectangle(position.x - 5 - margin, position.y + 9 + margin, 11 + 2 * margin, 16 + 2 * margin);
    }    
    
    public function active():Boolean
    {
      return (phase == 10);
    }    
    
    public function eat():void
    {
      if (active() && (!eaten))    
        eaten = true;
    }
    
    public function blink():Boolean
    {
      if (blinking == 0)  
        blinking = 70;
      
      blinking--;
      
      phase = blinking % 10;
      
      if (blinking / 10 % 2 == 1)
        phase = 10 - phase;
      
      return (blinking != 0);
    }    
    
    public function update():Boolean
    {
      if (eaten)
      {
        phase--;
        
        if (phase <= 0)
          return false;
      }
      else
      {
        phase++;
        
        if (phase > 10)
          phase = 10;
      }
      
      return true;
    }
    
    [Embed(source="../Images/Egg.png")] private var eggImg:Class;

    private var bitmap:BitmapData = null;
        
    public function draw(screenBuffer:BitmapData,visible:Rectangle):void
    {
      if (bitmap == null)
      {
        bitmap = new BitmapData(300,30,true,0x00000000);
        bitmap.draw(new eggImg());
      }    
    
      screenBuffer.copyPixels(bitmap,
                              new Rectangle(300 - phase * 30,0,30,30),
                              new Point(position.x - 15,visible.y - position.y - 15)); 
    }
  } 
}
