private static const OPTIONSIN_SOUND:int      = 1;
private static const OPTIONSOUT_SOUND:int     = 2;
private static const OPTIONSELECTED_SOUND:int = 3;
private static const ACTIVATED_SOUND:int      = 4;
private static const EGGCOLLECTED_SOUND:int   = 5;
private static const GAMEOVER_SOUND:int       = 6;

private var soundVolume:Number  = 0.7;
private var musicVolume:Number  = 0.7;
private var eggSoundCounter:int = 0;

[Embed(source="Sounds/OptionsIn.mp3")] private var optionsInSnd:Class;
[Embed(source="Sounds/OptionsOut.mp3")] private var optionsOutSnd:Class;
[Embed(source="Sounds/OptionSelected.mp3")] private var optionSelectedSnd:Class;
[Embed(source="Sounds/EggCollected1.mp3")] private var eggCollected1Snd:Class;
[Embed(source="Sounds/EggCollected2.mp3")] private var eggCollected2Snd:Class;
[Embed(source="Sounds/EggCollected3.mp3")] private var eggCollected3Snd:Class;
[Embed(source="Sounds/EggCollected4.mp3")] private var eggCollected4Snd:Class;
[Embed(source="Sounds/EggCollected5.mp3")] private var eggCollected5Snd:Class;
[Embed(source="Sounds/GameOver.mp3")] private var gameOverSnd:Class;

private function PlaySound(type:int) : void
{
  var sfx:Sound = null;

  switch (type)
  { 
  case ACTIVATED_SOUND:
    sfx = new optionSelectedSnd() as Sound;
    break; 
  case OPTIONSIN_SOUND:
    sfx = new optionsInSnd() as Sound;
    break;
  case OPTIONSOUT_SOUND:
    sfx = new optionsOutSnd() as Sound;
    break;
  case OPTIONSELECTED_SOUND:
    sfx = new optionSelectedSnd() as Sound;
    break; 
  case EGGCOLLECTED_SOUND:
    switch (eggSoundCounter)
    {
    case 0:
      sfx = new eggCollected1Snd() as Sound;
      break;
    case 1:
      sfx = new eggCollected2Snd() as Sound;
      break;
    case 2:
      sfx = new eggCollected3Snd() as Sound;
      break;      
    case 3:
      sfx = new eggCollected4Snd() as Sound;
      break;
    case 4:
      sfx = new eggCollected5Snd() as Sound;
      break;      
    }
    
    eggSoundCounter++;
    
    if (eggSoundCounter == 5)
      eggSoundCounter = 0;
    break;
  case GAMEOVER_SOUND:
    sfx = new gameOverSnd() as Sound;
    break;    
  }

  if (sfx != null)
    sfx.play(0,0,new SoundTransform(soundVolume));
}

